/*
 * Copyright(C) 2013 Intel Corporation.  All Rights Reserved.
 */



APT.createNamespace("APT");

APT.ApplicationBase = Class.$define("APT.ApplicationBase", {
    __init__: function() {
        this._delegate = null;
    },

    $copy: function() {
        var copyObject = new APT.ApplicationBase();
        copyObject._delegate = this._delegate;
        return copyObject;
    },

    delegate: function() {
        return this._delegate;
    },

    setDelegate: function(newDelegate) {
        this._delegate = newDelegate;
    },

    initialize: function() {
    },

    exec: function(delegateClassName) {
        this.initialize();
        if (this.delegate() !== null)
        {
            if (this.delegate()["application_didFinishLaunchingWithOptions"] instanceof Function)
            {
                this.delegate().application_didFinishLaunchingWithOptions(this, null);
            }
            else
            {
                this.delegate().applicationDidFinishLaunching(this);
            }
        }
        else
        {
            if (this.delegate() === null && delegateClassName !== undefined && delegateClassName !== null)
            {
                APT.Global.initWhitDelegateClassName(this, delegateClassName);
            }
        }
    },

    openURL: function(url) {
        if (url !== undefined && url !== null)
        {
            window.open(url.href);
            return true;
        }

        return false;
    },

    touchesBegan_withEvent: function(touches, e) {
    },

    touchesMoved_withEvent: function(touches, e) {
    },

    touchesEnded_withEvent: function(touches, e) {
    },

    touchesCancelled_withEvent: function(touches, e) {
    },

    becomeFirstResponder: function() {
        return false;
    },

    resignFirstResponder: function() {
        return false;
    },

});

APT.ApplicationBase._application = new APT.ApplicationBase();

APT.ApplicationBase.sharedApplication = function() {
    return APT.ApplicationBase._application;
};


