/*
 * Copyright(C) 2013 Intel Corporation.  All Rights Reserved.
 */



APT.createNamespace("APT");

APT.View = Class.$define("APT.View");
APT.Control = Class.$define("APT.Control", APT.View);

APT.BarButtonDefault = Class.$define("APT.BarButtonDefault", APT.Control, {
    __init__: function() {
        this._text = null;
        this._barButtonItem = null;
        this.$super();
    },

    $copy: function() {
        var copyObject = new APT.BarButtonDefault();
        copyObject._text = this._text;
        copyObject._barButtonItem = this._barButtonItem;
        return copyObject;
    },

    getRenderMarkup: function() {
        return $(APT.Global.toStaticHTML("<a data-role=\"button\" data-theme=\"b\" ></a>"));
    },

    setJQElement: function(jQElement) {
        jQElement.button();
        this._jqElement = jQElement;
        this._jqElement.css("margin", "3px");
    },

    text: function() {
        return this._text;
    },

    setText: function(aText) {
        this._text = aText;
        this.showText();
    },

    showText: function() {
        if (this._text !== null)
        {
            this.jQElement().children("span.ui-btn-inner").children("span.ui-btn-text").text(this._text.valueOf());
        }
        else
        {
            this.jQElement().children("span.ui-btn-inner").children("span.ui-btn-text").text("");
        }
    },

    processNode: function(markup, element) {
        var button = element.find("a");

        markup.text(button.text());

        this.setJQElement(markup);
    },

});


