/*
 * Copyright(C) 2013 Intel Corporation.  All Rights Reserved.
 */



APT.createNamespace("APT");

APT.Bundle = Class.$define("APT.Bundle", {
    __init__: function() {
        this._path = null;
    },

    $copy: function() {
        var copyObject = new APT.Bundle();
        copyObject._path = this._path;
        return copyObject;
    },

    pathForResource_ofType: function(fileName, fileExt) {
        var _pathName;
        _pathName = this._path + fileName + "." + fileExt;

        return _pathName;
    },

    resourcePath: function() {
        return this._path;
    },

    loadNibNamedOwner: function(aNibName, aViewController) {
        var className = aNibName + "Loader";
        var loader = APT.Global.createUserObject(className);
        loader.load(aViewController);
        if (aViewController["viewDidLoad"] instanceof Function)
        {
            aViewController.viewDidLoad();
        }
    },

});

APT.Bundle.mainBundle = function() {
    var bundle = new APT.Bundle();
    bundle._path = window.location.toString();

    var a = bundle._path.split("/").length;

    bundle._path = bundle._path.replace(bundle._path.split("/")[a - 1], "");
    return bundle;
};

APT.Bundle.pathForResource_ofType_inDirectory = function(fileName, fileExt, dirPath) {
    var _pathName;

    if (fileExt === null || fileExt === "")
    {
        _pathName = dirPath + fileName;
    }
    else
    {
        _pathName = dirPath + fileName + "." + fileExt;
    }

    return _pathName;
};


