/*
 * Copyright(C) 2013 Intel Corporation.  All Rights Reserved.
 */



APT.createNamespace("APT");

APT.View = Class.$define("APT.View");

APT.Control = Class.$define("APT.Control", APT.View, {
    __init__: function() {
        this.$super();
    },

    setJQElement: function(jqelement) {
        var aux = $(APT.Global.toStaticHTML("<div></div>"));
        aux.append(jqelement);
        this._jqElement = aux.trigger("create").children(1);
    },

    sendActionsForControlEvents: function(controlEvents) {
        if (APT.ControlEvent.vmousedown & controlEvents)
        {
            this.jQElement().trigger("vmousedown");
        }

        if (APT.ControlEvent.vmouseover & controlEvents)
        {
            this.jQElement().trigger("vmouseover");
        }

        if (APT.ControlEvent.vmouseup & controlEvents)
        {
            this.jQElement().trigger("vmouseup");
        }

        if (APT.ControlEvent.vmousecancel & controlEvents)
        {
            this.jQElement().trigger("vmousecancel");
        }

        if (APT.ControlEvent.focus & controlEvents)
        {
            this.jQElement().trigger("focus");
        }

        if (APT.ControlEvent.change & controlEvents)
        {
            this.jQElement().trigger("change");
        }

        if (APT.ControlEvent.blur & controlEvents)
        {
            this.jQElement().trigger("blur");
        }

        if (APT.ControlEvent.ValueChanged & controlEvents)
        {
            this.jQElement().trigger("change");
        }
    },

    addTarget_action_forControlEvents: function(targetObject, selector, controlEvents) {
        var sender = this;
        var eventHandler = function(event) {
            if (jQuery(this).attr("disabled") !== "disabled")
            {
                targetObject[selector.valueOf()](sender);
            }

            event.stopPropagation();
        };

        if (selector !== null && selector !== undefined && selector.valueOf() !== "")
        {
            var eventName = "." + selector;

            if (APT.ControlEvent.vmousedown & controlEvents)
            {
                this.jQElement().on("vmousedown" + eventName, eventHandler);
            }

            if (APT.ControlEvent.vmouseover & controlEvents)
            {
                this.jQElement().on("vmouseover" + eventName, eventHandler);
            }

            if (APT.ControlEvent.vmouseup & controlEvents)
            {
                this.jQElement().on("vmouseup" + eventName, eventHandler);
            }

            if (APT.ControlEvent.vmousecancel & controlEvents)
            {
                this.jQElement().on("vmousecancel" + eventName, eventHandler);
            }

            if (APT.ControlEvent.focus & controlEvents)
            {
                this.jQElement().on("focus" + eventName, eventHandler);
            }

            if (APT.ControlEvent.change & controlEvents)
            {
                this.jQElement().on("change" + eventName, eventHandler);
            }

            if (APT.ControlEvent.blur & controlEvents)
            {
                this.jQElement().on("blur" + eventName, eventHandler);
            }

            if (APT.ControlEvent.ValueChanged & controlEvents)
            {
                this.jQElement().on("change" + eventName, eventHandler);
            }
        }
    },

    removeTarget_action_forControlEvents: function(targetObject, selector, controlEvents) {
        var eventName = "";
        if (selector !== null && selector !== undefined)
        {
            eventName = "." + selector;
        }

        if (APT.ControlEvent.vmousedown & controlEvents)
        {
            this.jQElement().off("vmousedown" + eventName);
        }

        if (APT.ControlEvent.vmouseover & controlEvents)
        {
            this.jQElement().off("vmouseover" + eventName);
        }

        if (APT.ControlEvent.vmouseup & controlEvents)
        {
            this.jQElement().off("vmouseup" + eventName);
        }

        if (APT.ControlEvent.vmousecancel & controlEvents)
        {
            this.jQElement().off("vmousecancel" + eventName);
        }

        if (APT.ControlEvent.focus & controlEvents)
        {
            this.jQElement().off("focus" + eventName);
        }

        if (APT.ControlEvent.change & controlEvents)
        {
            this.jQElement().off("change" + eventName);
        }

        if (APT.ControlEvent.blur & controlEvents)
        {
            this.jQElement().off("blur" + eventName);
        }

        if (APT.ControlEvent.ValueChanged & controlEvents)
        {
            this.jQElement().off("change" + eventName);
        }
    },

    isEnabled: function() {
        var aEnabled = this.jQElement().attr("disabled");
        if (aEnabled === "disabled")
        {
            return false;
        }
        else
        {
            return true;
        }
    },

    setEnabled: function(enabled) {
        if (enabled)
        {
            this.jQElement().removeClass("ui-disabled");
            this.jQElement().removeAttr("disabled");
        }
        else
        {
            this.jQElement().addClass("ui-disabled");
            this.jQElement().attr("disabled", "disabled");
        }
    },

});


