/*
 * Copyright(C) 2013 Intel Corporation.  All Rights Reserved.
 */



APT.createNamespace("APT");

APT.Set = Class.$define("APT.Set");

APT.CountedSet = Class.$define("APT.CountedSet", APT.Set, {
    __init__: function() {
        this.$super();
    },

    initWithArray: function(anArray) {
        for (var i = 0; i < anArray.length; i++)
        {
            this.addObject(anArray[i]);
        }

        return this;
    },

    initWithSet: function(aSet) {
        var anArray = aSet.allObjects();
        for (var i = 0; i < anArray.length; i++)
        {
            this.addObject(anArray[i]);
        }

        return this;
    },

    addObject: function(element) {
        if (!this.containsObject(element))
        {
            this._array.push(element);
            this[element] = 1;
        }
        else
        {
            var aux = this[element];
            var x = parseInt(aux);
            this[element] = ++x;
        }
    },

    removeObject: function(element) {
        var i = 0;
        for (i = 0; i < this.length(); i++)
        {
            if (APT.Global.isEqual(this._array[i], element))
            {
                break;
            }
        }

        if (i !== this.length())
        {
            var aux = this[element];
            var x = parseInt(aux);
            if (--x === 0)
            {
                this._array.splice(i, 1);
            }

            this[element] = x;
        }
    },

    removeAllObjects: function() {
        for (var i = 0; i < this.length(); i++)
        {
            this[this._array[i]] = 0;
        }

        this._array.splice(0, this.length());
    },

    getEnumerator: function() {
        return APT.Enumerator.New(this._array);
    },

    countForObject: function(element) {
        var aux = this[element];
        return parseInt(aux);
    },

});


