/*
 * Copyright(C) 2013 Intel Corporation.  All Rights Reserved.
 */



APT.createNamespace("APT");

APT.NavigationItem = Class.$define("APT.NavigationItem", {
    __init__: function() {
        this._jqElement = null;
        this._title = null;
        this._titleView = null;
        this._backBarButtonItem = null;
        this._leftBarButtonItems = null;
        this._rightBarButtonItems = null;
        this._prompt = null;
        this._navigationBar = null;
        this._leftItemsSupplementBackButton = null;
        this._hidesBackButton = null;
        this._leftItemsSupplementBackButton = false;
        this._hidesBackButton = false;
        this._leftBarButtonItems = new Array();
        this._rightBarButtonItems = new Array();
        if (this.jQElement() === null)
        {
            this.setJQElement(this.getRenderMarkup());
        }
    },

    $copy: function() {
        var copyObject = new APT.NavigationItem();
        copyObject._jqElement = this._jqElement;
        copyObject._title = this._title;
        copyObject._titleView = this._titleView;
        copyObject._backBarButtonItem = this._backBarButtonItem;
        copyObject._leftBarButtonItems = this._leftBarButtonItems;
        copyObject._rightBarButtonItems = this._rightBarButtonItems;
        copyObject._prompt = this._prompt;
        copyObject._navigationBar = this._navigationBar;
        copyObject._leftItemsSupplementBackButton = this._leftItemsSupplementBackButton;
        copyObject._hidesBackButton = this._hidesBackButton;
        return copyObject;
    },

    getRenderMarkup: function() {
        return $("<div><div data-role=\"controlgroup\" data-type=\"horizontal\" class=\"ui-btn-left\"></div><div class=\"ui-title\"><div class=\"apt_navbar_prompt\" /><div class=\"apt_navbar_title\" /></div><div data-role=\"controlgroup\" data-type=\"horizontal\" class=\"ui-btn-right\"></div></div>");
    },

    setJQElement: function(jqelement) {
        this._jqElement = jqelement.trigger("create");
    },

    jQElement: function() {
        return this._jqElement;
    },

    initWithTitle: function(aTitle) {
        this.setTitle(aTitle);
        return this;
    },

    setTitle: function(aTitle) {
        this._title = aTitle;
        if (this._navigationBar !== null)
        {
            this._navigationBar.displayCenterItems();
        }
    },

    title: function() {
        return this._title;
    },

    setBackBarButtonItem: function(aButtonItem) {
        this._backBarButtonItem = aButtonItem;
        if (this._navigationBar !== null)
        {
            this._navigationBar.displayLeftItems(false);
        }
    },

    backBarButtonItem: function() {
        return this._backBarButtonItem;
    },

    setLeftBarButtonItem: function(aButtonItem) {
        this._leftBarButtonItems[0] = aButtonItem;
        if (this._navigationBar !== null)
        {
            this._navigationBar.displayLeftItems(false);
        }
    },

    leftBarButtonItem: function() {
        return this._leftBarButtonItems[0];
    },

    setLeftBarButtonItems: function(aLeftButtonItemsArray) {
        this._leftBarButtonItems = aLeftButtonItemsArray;
        if (this._navigationBar !== null)
        {
            this._navigationBar.displayLeftItems(false);
        }
    },

    leftBarButtonItems: function() {
        return this._leftBarButtonItems;
    },

    setRightBarButtonItem: function(aButtonItem) {
        this._rightBarButtonItems[0] = aButtonItem;
        if (this._navigationBar !== null)
        {
            this._navigationBar.displayRightItems(false);
        }
    },

    rightBarButtonItem: function() {
        return this._rightBarButtonItems[0];
    },

    setRightBarButtonItems: function(aRightButtonItems) {
        this._rightBarButtonItems = aRightButtonItems;
        if (this._navigationBar !== null)
        {
            this._navigationBar.displayRightItems(false);
        }
    },

    rightBarButtonItems: function() {
        return this._rightBarButtonItems;
    },

    setPrompt: function(aPrompt) {
        this._prompt = aPrompt;
    },

    prompt: function() {
        return this._prompt;
    },

    setHidesBackButton: function(aHidesBackButton) {
        this._hidesBackButton = aHidesBackButton;
    },

    hidesBackButton: function() {
        return this._hidesBackButton;
    },

    setLeftItemsSupplementBackButton: function(aLeftItemsSupplementBackButton) {
        this._leftItemsSupplementBackButton = aLeftItemsSupplementBackButton;
    },

    leftItemsSupplementBackButton: function() {
        return this._leftItemsSupplementBackButton;
    },

    setNavigationBar: function(aNavigationBar) {
        this._navigationBar = aNavigationBar;
    },

    processNode: function(markup, element) {
        var left = element.find(".ui-btn-left");
        var aButtonItem;
        if (left.length === 1)
        {
            aButtonItem = new APT.BarButtonItem();
            aButtonItem.defaultView().jQElement().attr("id", jQuery(left.children()[0]).attr("id"));
            aButtonItem.setTitle(jQuery(left.children()[0]).text());
            this.setLeftBarButtonItem(aButtonItem);
        }

        var right = element.find(".ui-btn-right");
        if (right.length === 1)
        {
            aButtonItem = new APT.BarButtonItem();
            aButtonItem.defaultView().jQElement().attr("id", jQuery(right.children()[0]).attr("id"));
            aButtonItem.setTitle(jQuery(right.children()[0]).text());
            this.setRightBarButtonItem(aButtonItem);
        }

        var title = element.find(".apt_navbar_title").text();
        var prompt = element.find(".apt_navbar_prompt").text();

        this.initWithTitle(title);
        this.setPrompt(prompt);

        this.setJQElement(markup);
    },

});


