/*
 * Copyright(C) 2013 Intel Corporation.  All Rights Reserved.
 */



APT.createNamespace("APT");

APT.Point = Class.$define("APT.Point", {
    __init__: function(x, y) {
        this.x = 0;
        this.y = 0;
        if (arguments.length > 0)
        {
            this.x = x;
            this.y = y;
        }
    },

    $copy: function() {
        var copyObject = new APT.Point();
        copyObject.x = this.x;
        copyObject.y = this.y;
        return copyObject;
    },

});

APT.Point.updateFromCSS = function(jqobject) {
    var x = "0";
    var y = "0";
    if (jqobject.css("left") !== undefined && jqobject.css("left") !== null)
    {
        x = jqobject.css("left").replace("px", "");
        y = jqobject.css("top").replace("px", "");
    }

    return new APT.Point(parseFloat(x), parseFloat(y));
};

APT.Point.updateCSS = function(jqobject, point) {
    point = point.$copy();
    jqobject.css("left", point.x);
    jqobject.css("top", point.y);
};

APT.Point.EqualToPoint = function(arg1, arg2) {
    arg1 = arg1.$copy();
    arg2 = arg2.$copy();
    if (arg1.x === arg2.x && arg1.y === arg2.y)
    {
        return true;
    }

    return false;
};

APT.Point.Zero = function() {
    return new APT.Point(0, 0);
};


