/*
 * Copyright(C) 2013 Intel Corporation.  All Rights Reserved.
 */



APT.createNamespace("APT");

APT.View = Class.$define("APT.View");

APT.ProgressView = Class.$define("APT.ProgressView", APT.View, {
    __init__: function() {
        this.$super();
    },

    getRenderMarkup: function() {
        return $(APT.Global.toStaticHTML("<progress max=\"1\" value=\"0\"></progress>"));
    },

    setJQElement: function(jqelement) {
        this._jqElement = jqelement;
        this.setProgressViewStyle(APT.ProgressViewStyle.Default);

        this.setProperties();
    },

    initWithProgressViewStyle: function(aStyle) {
        this.setProgressViewStyle(aStyle);
        return this;
    },

    progressViewStyle: function() {
        if (this.jQElement().attr("class").toString() === "apt_progressViewStyle_bar")
        {
            return APT.ProgressViewStyle.Bar;
        }
        else
        {
            return APT.ProgressViewStyle.Default;
        }
    },

    setProgressViewStyle: function(aStyle) {
        switch(aStyle)
        {

            case APT.ProgressViewStyle.Default:
                this.jQElement().removeClass("apt_progressViewStyle_bar");
                this.jQElement().removeClass("apt_progressViewStyle_default");
                this.jQElement().addClass("apt_progressViewStyle_default");
                break;
            case APT.ProgressViewStyle.Bar:
                this.jQElement().removeClass("apt_progressViewStyle_bar");
                this.jQElement().removeClass("apt_progressViewStyle_default");
                this.jQElement().addClass("apt_progressViewStyle_bar");
                break;
        }
    },

    setProgress: function(value) {
        this.jQElement().val(value);
    },

    progress: function() {
        var progress = parseFloat(this.jQElement().val());
        return progress;
    },

    animateProgressBar: function(value) {
        var interval = 0.01;
        var updatesPerSecond = 1000 / 60;
        var progress = this.jQElement();
        var animator = function() {
            if (value > progress.val())
            {
                progress.val(progress.val() + interval);
                if (progress.val() + interval < value)
                {
                    window.setTimeout(animator, updatesPerSecond);
                }
                else
                {
                    progress.val(value);
                }
            }
            else
            {
                progress.val(progress.val() - interval);
                if (progress.val() - interval > value)
                {
                    window.setTimeout(animator, updatesPerSecond);
                }
                else
                {
                    progress.val(value);
                }
            }
        };

        animator();
    },

    setProgressAnimated: function(value, animated) {
        if (animated)
        {
            this.animateProgressBar(value);
        }
        else
        {
            this.jQElement().val(value);
        }
    },

});


