/*
 * Copyright(C) 2013 Intel Corporation.  All Rights Reserved.
 */



APT.createNamespace("APT");

APT.Screen = Class.$define("APT.Screen", {
    __init__: function() {
        this._bounds = null;
        this._applicationFrame = null;
    },

    $copy: function() {
        var copyObject = new APT.Screen();
        copyObject._bounds = this._bounds.$copy();
        copyObject._applicationFrame = this._applicationFrame.$copy();
        return copyObject;
    },

    bounds: function() {
        return this._bounds;
    },

    applicationFrame: function() {
        return this._applicationFrame;
    },

    setBounds: function(bounds) {
        bounds = bounds.$copy();
        this._bounds = bounds.$copy();
        this._applicationFrame = bounds.$copy();
    },

});

APT.Screen.MainScreen = function() {
    return APT.Screen.CreateMainScreen();
};

APT.Screen.CreateMainScreen = function() {
    var main = new APT.Screen();
    var w = 0;
    var h = 0;
    if (window.innerWidth === null || window.innerWidth === undefined)
    {
        w = document.documentElement.offsetWidth;
    }
    else
    {
        if (window.frameElement !== null && window.frameElement !== undefined && parseInt(window.frameElement.width) !== 0)
        {
            w = window.frameElement.width;
        }
        else
        {
            if (screen !== null && parseInt(window.innerWidth) < screen.width)
            {
                w = screen.width;
            }
            else
            {
                w = window.innerWidth;
            }
        }
    }

    if (window.innerHeight === null || window.innerHeight === undefined)
    {
        h = document.documentElement.offsetHeight;
    }
    else
    {
        if (window.frameElement !== null && window.frameElement !== undefined && parseInt(window.frameElement.height) !== 0)
        {
            h = window.frameElement.height;
        }
        else
        {
            if (screen !== null && parseInt(window.innerHeight) < screen.height)
            {
                h = screen.height;
            }
            else
            {
                h = window.innerHeight;
            }
        }
    }

    main.setBounds(new APT.Rect(new APT.Point(0, 0), new APT.Size(w, h)));

    return main;
};


