/*
 * Copyright(C) 2013 Intel Corporation.  All Rights Reserved.
 */



APT.createNamespace("APT");

APT.Size = Class.$define("APT.Size", {
    __init__: function(width, height) {
        this.width = 0;
        this.height = 0;
        if (arguments.length > 0)
        {
            this.width = width;
            this.height = height;
        }
    },

    $copy: function() {
        var copyObject = new APT.Size();
        copyObject.width = this.width;
        copyObject.height = this.height;
        return copyObject;
    },

});

APT.Size.updateFromCSS = function(jqobject) {
    var width = "0";
    var height = "0";
    if (jqobject.css("left") !== undefined && jqobject.css("left") !== null)
    {
        width = jqobject.css("width").replace("px", "");
        height = jqobject.css("height").replace("px", "");
    }

    return new APT.Size(parseFloat(width), parseFloat(height));
};

APT.Size.updateCSS = function(jqobject, size) {
    size = size.$copy();
    jqobject.css("width", size.width);
    jqobject.css("height", size.height);
};

APT.Size.EqualToSize = function(arg1, arg2) {
    arg1 = arg1.$copy();
    arg2 = arg2.$copy();
    if (arg1.width === arg2.width && arg1.height === arg2.height)
    {
        return true;
    }

    return false;
};

APT.Size.Zero = function() {
    return new APT.Size(0, 0);
};


