/*
 * Copyright(C) 2013 Intel Corporation.  All Rights Reserved.
 */



APT.createNamespace("APT");

APT.ViewController = Class.$define("APT.ViewController");

APT.SplitViewController = Class.$define("APT.SplitViewController", APT.ViewController, {
    __init__: function() {
        this._viewControllers = null;
        this._delegate = null;
        this.$super();
    },

    $copy: function() {
        var copyObject = new APT.SplitViewController();
        copyObject._viewControllers = this._viewControllers;
        copyObject._delegate = this._delegate;
        return copyObject;
    },

    viewControllers: function() {
        return this._viewControllers;
    },

    setViewControllers: function(aViewControllers) {
        var viewController;
        var aView;
        if (this._viewControllers === null)
        {
            this.setView(new APT.View());
            for (var i = 0; i < aViewControllers.length; i++)
            {
                viewController = aViewControllers[i];
                aView = viewController.view();
                if (i === 0)
                {
                    aView.jQElement().css("width", "20%");
                    aView.jQElement().css("float", "left");
                }
                else
                {
                    aView.jQElement().css("width", "80%");
                    aView.jQElement().css("float", "right");
                }

                aView.jQElement().css("top", 0);
                aView.jQElement().css("height", "100%");
                aView.jQElement().css("position", "relative");
                this.view().addSubview(aView);
            }
        }
        else
        {
            viewController = aViewControllers[1];
            aView = viewController.view();
            var aViewAux = this.view().subviews()[1];
            if (this.view().subviews()[1] !== aView)
            {
                aViewAux.removeFromSuperview();
                aView.jQElement().css("width", "80%");
                aView.jQElement().css("float", "right");
                aView.jQElement().css("top", 0);
                aView.jQElement().css("height", "100%");
                aView.jQElement().css("position", "relative");
                this.view().insertSubviewAtIndex(aView, 1);
            }
        }

        this._viewControllers = aViewControllers;
    },

    setDelegate: function(aDelegate) {
        this._delegate = aDelegate;
    },

    delegate: function() {
        return this._delegate;
    },

    presentsWithGesture: function() {
        return true;
    },

    presentsWithGesture: function(hidden) {
    },

});


