/*
 * Copyright(C) 2013 Intel Corporation.  All Rights Reserved.
 */



APT.createNamespace("APT");

APT.View = Class.$define("APT.View");
APT.Control = Class.$define("APT.Control", APT.View);

APT.Switch = Class.$define("APT.Switch", APT.Control, {
    __init__: function() {
        this._requireRefresh = false;
        this.$super();
    },

    $copy: function() {
        var copyObject = new APT.Switch();
        copyObject._requireRefresh = this._requireRefresh;
        return copyObject;
    },

    getRenderMarkup: function() {
        return $(APT.Global.toStaticHTML("<div><select data-role=\"slider\"><option value=\"off\">Off</option><option value=\"on\">On</option></select></div>"));
    },

    setJQElement: function(jqelement) {
        this._jqElement = jqelement;
        this._jqElement.find("select").slider();

        this.setProperties();
    },

    initWithFrame: function(rect) {
        rect = rect.$copy();
        this.jQElement().css("position", "absolute");
        this.setFrame(rect);

        return this;
    },

    setFrame: function(aFrame) {
        aFrame = aFrame.$copy();
        this._jqElement.css("position", "absolute");
        APT.Point.updateCSS(this._jqElement, aFrame.origin);
        APT.Size.updateCSS(this._jqElement, new APT.Size(94, 42));
    },

    setBounds: function(aRect) {
        aRect = aRect.$copy();
    },

    setOn: function(on) {
        if (on)
        {
            this.jQElement().find("select").val("on");
        }
        else
        {
            this.jQElement().find("select").val("off");
        }

        if (this.isInDom())
        {
            this.jQElement().find("select").slider("refresh");
        }
        else
        {
            this._requireRefresh = true;
        }
    },

    on: function() {
        var value = false;
        if (this.jQElement().find("select").val() === "on")
        {
            value = true;
        }
        return value;
    },

    processNode: function(markup, element) {
        var selected = element.find("option[value='on']").attr("selected");
        if (selected !== "false")
        {
            markup.find("option[value='on']").attr("selected", "selected");
        }

        this.setJQElement(markup);
    },

    viewDidAppear: function(animated) {
        this.$super(animated);
        if (this._requireRefresh)
        {
            this._requireRefresh = false;
            this.jQElement().find("select").slider("refresh");
        }
    },

    setUserInteractionEnabled: function(enabled) {
        var options = new Array();
        options["disabled"] = !enabled;
        this.jQElement().find("select").slider(options);
    },

    isUserInteractionEnabled: function() {
        return !this.jQElement().find("select").slider("option", "disabled");
    },

});


