/*
 * Copyright(C) 2013 Intel Corporation.  All Rights Reserved.
 */



APT.createNamespace("APT");

APT.ViewController = Class.$define("APT.ViewController", {
    __init__: function() {
        this._navigationItem = null;
        this._navigationController = null;
        this._title = null;
        this._tabBarItem = null;
        this._tabBarController = null;
        this._toolbarItems = null;
        this._hidesBottomBarWhenPushed = true;
        this._viewDidLoadCalled = false;
        this._view = null;
    },

    $copy: function() {
        var copyObject = new APT.ViewController();
        copyObject._navigationItem = this._navigationItem;
        copyObject._navigationController = this._navigationController;
        copyObject._title = this._title;
        copyObject._tabBarItem = this._tabBarItem;
        copyObject._tabBarController = this._tabBarController;
        copyObject._toolbarItems = this._toolbarItems;
        copyObject._hidesBottomBarWhenPushed = this._hidesBottomBarWhenPushed;
        copyObject._viewDidLoadCalled = this._viewDidLoadCalled;
        copyObject._view = this._view;
        return copyObject;
    },

    view: function() {
        if (this._view === null)
        {
            this._viewDidLoadCalled = true;
            this.loadView();
            this.viewDidLoad();
            if (this._view !== null && this._view !== undefined)
            {
                this._view.setViewController(this);
                this.configureTouchEvents();
            }
        }
        else
        {
            if (!this._viewDidLoadCalled)
            {
                this._viewDidLoadCalled = true;
                this.viewDidLoad();
            }
        }

        return this._view;
    },

    configureTouchEvents: function() {
        var _viewControlerAux = this;

        var downevent;
        var upevent;
        var moveevent;
        var cancelevent;

        if (navigator.msPointerEnabled)
        {
            downevent = "MSPointerDown";
            upevent = "MSPointerUp";
            moveevent = "MSPointerMove";
            cancelevent = "MSPointerCancel";
        }
        else
        {
            downevent = "touchstart";
            upevent = "touchend";
            moveevent = "touchmove";
            cancelevent = "touchcancel";
        }

        this._view.jQElement().on(downevent, function(event) {
            var arrayAux = new Array();
            var touch = null;
            var x = 0;
            var y = 0;

            if (jQuery(event.currentTarget).parents(".apt_scrollview").length > 0)
            {
                x = jQuery(event.currentTarget).parents(".apt_scrollview").scrollLeft();
                y = jQuery(event.currentTarget).parents(".apt_scrollview").scrollTop();
            }
            else
            {
                if (jQuery(event.currentTarget).find(".apt_scrollview").length > 0)
                {
                    x = jQuery(event.currentTarget).find(".apt_scrollview").scrollLeft();
                    y = jQuery(event.currentTarget).find(".apt_scrollview").scrollTop();
                }
            }

            if (event.type === "MSPointerDown")
            {
                touch = new APT.Touch(x + event.originalEvent.pageX, y + event.originalEvent.pageY, _viewControlerAux.view());
                arrayAux[0] = touch;
            }
            else
            {
                for (var i = 0; i < event.originalEvent.targetTouches.length; i++)
                {
                    touch = new APT.Touch(x + event.originalEvent.targetTouches[i].clientX, y + event.originalEvent.targetTouches[i].clientY, _viewControlerAux.view());
                    arrayAux[i] = touch;
                }
            }

            var touches = APT.Set.NewWithObjects(arrayAux);
            var e = new APT.Event();
            e._evnt = event;
            e.setTouches(touches);
            _viewControlerAux.touchesBegan_withEvent(touches, e);
            event.stopPropagation();
        });

        this._view.jQElement().on(moveevent, function(event) {
            var arrayAux = new Array();
            var touch;
            var x = 0;
            var y = 0;

            if (jQuery(event.currentTarget).parents(".apt_scrollview").length > 0)
            {
                x = jQuery(event.currentTarget).parents(".apt_scrollview").scrollLeft();
                y = jQuery(event.currentTarget).parents(".apt_scrollview").scrollTop();
            }
            else
            {
                if (jQuery(event.currentTarget).find(".apt_scrollview").length > 0)
                {
                    x = jQuery(event.currentTarget).find(".apt_scrollview").scrollLeft();
                    y = jQuery(event.currentTarget).find(".apt_scrollview").scrollTop();
                }
            }

            if (event.type === "MSPointerMove")
            {
                touch = new APT.Touch(x + event.originalEvent.pageX, y + event.originalEvent.pageY, _viewControlerAux.view());
                arrayAux[0] = touch;
            }
            else
            {
                for (var i = 0; i < event.originalEvent.changedTouches.length; i++)
                {
                    touch = new APT.Touch(x + event.originalEvent.changedTouches[i].clientX, y + event.originalEvent.changedTouches[i].clientY, _viewControlerAux.view());
                    arrayAux[i] = touch;
                }
            }

            var touches = APT.Set.NewWithObjects(arrayAux);
            var e = new APT.Event();
            e._evnt = event;
            e.setTouches(touches);
            _viewControlerAux.touchesMoved_withEvent(touches, e);
            event.stopPropagation();
        });

        this._view.jQElement().on(upevent, function(event) {
            var arrayAux = new Array();
            var touch;
            var x = 0;
            var y = 0;

            if (jQuery(event.currentTarget).parents(".apt_scrollview").length > 0)
            {
                x = jQuery(event.currentTarget).parents(".apt_scrollview").scrollLeft();
                y = jQuery(event.currentTarget).parents(".apt_scrollview").scrollTop();
            }
            else
            {
                if (jQuery(event.currentTarget).find(".apt_scrollview").length > 0)
                {
                    x = jQuery(event.currentTarget).find(".apt_scrollview").scrollLeft();
                    y = jQuery(event.currentTarget).find(".apt_scrollview").scrollTop();
                }
            }

            if (event.type === "MSPointerUp")
            {
                touch = new APT.Touch(x + event.originalEvent.pageX, y + event.originalEvent.pageY, _viewControlerAux.view());
                arrayAux[0] = touch;
            }
            else
            {
                for (var i = 0; i < event.originalEvent.changedTouches.length; i++)
                {
                    touch = new APT.Touch(x + event.originalEvent.changedTouches[i].clientX, y + event.originalEvent.changedTouches[i].clientY, _viewControlerAux.view());
                    arrayAux[i] = touch;
                }
            }

            var touches = APT.Set.NewWithObjects(arrayAux);
            var e = new APT.Event();
            e._evnt = event;
            e.setTouches(touches);
            _viewControlerAux.touchesEnded_withEvent(touches, e);
            event.stopPropagation();
        });

        this._view.jQElement().on(cancelevent, function(event) {
            var arrayAux = new Array();
            var touch;
            var x = 0;
            var y = 0;

            if (jQuery(event.currentTarget).parents(".apt_scrollview").length > 0)
            {
                x = jQuery(event.currentTarget).parents(".apt_scrollview").scrollLeft();
                y = jQuery(event.currentTarget).parents(".apt_scrollview").scrollTop();
            }
            else
            {
                if (jQuery(event.currentTarget).find(".apt_scrollview").length > 0)
                {
                    x = jQuery(event.currentTarget).find(".apt_scrollview").scrollLeft();
                    y = jQuery(event.currentTarget).find(".apt_scrollview").scrollTop();
                }
            }

            if (event.type === "MSPointerCancel")
            {
                touch = new APT.Touch(x + event.originalEvent.pageX, y + event.originalEvent.pageY, _viewControlerAux.view());
                arrayAux[0] = touch;
            }
            else
            {
                for (var i = 0; i < event.originalEvent.targetTouches.length; i++)
                {
                    touch = new APT.Touch(x + event.originalEvent.targetTouches[i].clientX, y + event.originalEvent.targetTouches[i].clientY, _viewControlerAux.view());
                    arrayAux[i] = touch;
                }
            }

            var touches = APT.Set.NewWithObjects(arrayAux);
            var e = new APT.Event();
            e._evnt = event;
            e.setTouches(touches);
            _viewControlerAux.touchesCancelled_withEvent(touches, e);
            event.stopPropagation();
        });
    },

    setView: function(newView) {
        if (newView !== null && newView !== undefined)
        {
            this._view = newView;
            newView.setViewController(this);
            this.configureTouchEvents();
        }
    },

    loadView: function() {
    },

    navigationItem: function() {
        if (this._navigationItem === null)
        {
            this._navigationItem = new APT.NavigationItem();
            this._navigationItem.setTitle(this.title());
        }

        return this._navigationItem;
    },

    setNavigationItem: function(navigationItem) {
        this._navigationItem = navigationItem;
    },

    setTitle: function(aTitle) {
        this._title = aTitle;
        if (this._navigationItem !== null)
        {
            this.navigationItem().setTitle(aTitle);
        }

        if (this._tabBarItem !== null)
        {
            this.tabBarItem().setTitle(aTitle);
        }

        if (this.isNavigationRoot())
        {
            this._navigationController.setTitle(aTitle);
        }
    },

    title: function() {
        return this._title;
    },

    setNavigationController: function(aNavigationController) {
        this._navigationController = aNavigationController;
        if (aNavigationController === null || aNavigationController === undefined)
        {
            this.setTabBarController(null);
        }
        else
        {
            if (aNavigationController.tabBarController() !== null && aNavigationController.tabBarController() !== undefined)
            {
                this.setTabBarController(aNavigationController.tabBarController());
            }
        }
    },

    navigationController: function() {
        return this._navigationController;
    },

    tabBarItem: function() {
        if (this._tabBarItem === null)
        {
            this._tabBarItem = new APT.TabBarItem();
            this._tabBarItem.setTitle(this.title());
        }

        return this._tabBarItem;
    },

    setTabBarItem: function(aTabBarItem) {
        this._tabBarItem = aTabBarItem;
    },

    tabBarController: function() {
        return this._tabBarController;
    },

    setTabBarController: function(aTabBarController) {
        this._tabBarController = aTabBarController;
    },

    initWithNibName: function(aNibName) {
        var className = aNibName + "Loader";
        var loader = APT.Global.createUserObject(className);
        loader.load(this);
        this._viewDidLoadCalled = false;
        this.configureTouchEvents();
        return this;
    },

    didReceiveMemoryWarning: function() {
    },

    viewDidLoad: function() {
    },

    viewDidUnload: function() {
    },

    viewWillAppear: function(animated) {
    },

    viewDidAppear: function(animated) {
    },

    viewWillDisappear: function(animated) {
    },

    viewDidDisappear: function(animated) {
    },

    touchesBegan_withEvent: function(touches, e) {
    },

    touchesMoved_withEvent: function(touches, e) {
    },

    touchesEnded_withEvent: function(touches, e) {
    },

    touchesCancelled_withEvent: function(touches, e) {
    },

    becomeFirstResponder: function() {
        return false;
    },

    resignFirstResponder: function() {
        return false;
    },

    toolbarItems: function() {
        return this._toolbarItems;
    },

    setToolbarItems: function(toolbarItems) {
        this._toolbarItems = toolbarItems;
    },

    hidesBottomBarWhenPushed: function() {
        return this._hidesBottomBarWhenPushed;
    },

    setHidesBottomBarWhenPushed: function(hidesBottomBarWhenPushed) {
        this._hidesBottomBarWhenPushed = hidesBottomBarWhenPushed;
    },

    viewWillLayoutSubviews: function() {
    },

    viewDidLayoutSubviews: function() {
    },

    shouldAutorotateToInterfaceOrientation: function(interfaceOrientation) {
        return true;
    },

    isNavigationRoot: function() {
        var result = false;
        if (this._navigationController !== null && this._navigationController !== undefined)
        {
            var viewControllers = this._navigationController.viewControllers();
            if (viewControllers !== null && viewControllers.length > 0)
            {
                result = viewControllers[0] === this;
            }
        }

        return result;
    },

});


