/*
 * Copyright(C) 2013 Intel Corporation.  All Rights Reserved.
 */



APT.createNamespace("APT");

APT.View = Class.$define("APT.View");

APT.WebView = Class.$define("APT.WebView", APT.View, {
    __init__: function() {
        this._delegate = null;
        this._request = null;
        this.$super();
    },

    $copy: function() {
        var copyObject = new APT.WebView();
        copyObject._delegate = this._delegate;
        copyObject._request = this._request;
        return copyObject;
    },

    getRenderMarkup: function() {
        return $(APT.Global.toStaticHTML("<div></div>"));
    },

    setJQElement: function(jqelement) {
        this._jqElement = jqelement.trigger("create");
        this.setProperties();
        this._request = new APT.URLRequest();
    },

    loadHTMLString_baseURL: function(htmlString, url) {
        var newBaseURLJQ = $(this._request.url());
        var thisURLJQ = $(this._request.url());
        if (thisURLJQ.attr("data-apt-baseURL"))
        {
            this._request.url().href = this._request.url().href.replace(thisURLJQ.attr("data-apt-baseURL"), "");
        }

        if (url !== null && url !== undefined && url.href !== null && url.href !== undefined)
        {
            this._request.url().href = url.href + this._request.url().href;
            $(this._request.url()).attr("data-apt-baseURL", url.href);
        }

        var html = $(htmlString.valueOf());
        this.jQElement().children().remove();
        this.jQElement().append(html);
    },

    loadRequest: function(urlRequest) {
        this._request = urlRequest;
        var iframe = $("<div><iframe></iframe></div>").trigger("create").children(1);
        iframe.attr("src", urlRequest.url().href);
        var size = APT.Size.updateFromCSS(this.jQElement());
        APT.Size.updateCSS(iframe, size);
        this.jQElement().append(iframe);
    },

    stringByEvaluatingJavaScriptFromString: function(aScript) {
        var runAScript = new Function("return " + aScript.valueOf());
        return new String(runAScript.apply());
    },

    setDelegate: function(aDelegate) {
        this._delegate = aDelegate;
    },

    delegate: function() {
        return this._delegate;
    },

});


