/*
 * Copyright(C) 2013 Intel Corporation.  All Rights Reserved.
 */



/*
 * This file was modified by Intel Corporation.
 * Copyright(C) 2013 Intel Corporation. All Rights Reserved.
 */

/**
NOTE: some portions of code of the file "apt.util.js" are based on
the sprintf() for JavaScript 0.6 code
----------------------------------------------------------------------------
(http://www.diveintojavascript.com/projects/javascript-sprintf)

sprintf() for JavaScript 0.6

Copyright (c) Alexandru Marasteanu <alexaholic [at) gmail (dot] com>
All rights reserved.

Redistribution and use in source and binary forms, with or without
modification, are permitted provided that the following conditions are met:
* Redistributions of source code must retain the above copyright
notice, this list of conditions and the following disclaimer.
* Redistributions in binary form must reproduce the above copyright
notice, this list of conditions and the following disclaimer in the
documentation and/or other materials provided with the distribution.
* Neither the name of sprintf() for JavaScript nor the
names of its contributors may be used to endorse or promote products
derived from this software without specific prior written permission.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
DISCLAIMED. IN NO EVENT SHALL Alexandru Marasteanu BE LIABLE FOR ANY
DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
(INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
(INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
----------------------------------------------------------------------------
*/

String.prototype.apt_rangeOfString_range = function (str, aRange) {
	var apt_range = new APT.Range();
	var tempString = this;
	if (aRange) {
		tempString = this.substr(aRange.location, aRange.length);
	} else {
		aRange = new APT.Range(0, this.length);
	}

	if (tempString.indexOf(str) >= 0 && str.length > 0) {
		apt_range.location = aRange.location + tempString.indexOf(str);
		apt_range.length = str.length;
	} else {
		apt_range.location = APT.Global.NotFound;
		apt_range.length = 0;
	}
	return apt_range;
};

String.prototype.apt_hasPrefix = function(str) {
    if (str.length == 0)
        return false;

    temp = this.substr(0, str.length);
    if (str == temp)
        return true;

    return false;
};

String.prototype.apt_hasSuffix = function(str) {
    if (str.length == 0)
        return false;

    if (str.length > this.length)
        return false;

    temp = this.substr(this.length - str.length, this.length);
    if (str == temp)
        return true;
    return false;
};

String.prototype.apt_boolValue = function() {
    i = 0;
    while (this.charAt(i) == ' ')
        i += 1;

    c = this.charAt(i);
    if (c == 't' || c == 'T' || c == 'Y' || c == 'y')
        return true;
    else if (!isNaN(parseInt(this.substring(i))) && parseInt(this.substring(i)) != 0)
        return true;

    return false;
};

String.prototype.apt_compare = function(str) {
    if (this > str) return APT.ComparisonResult.OrderedDescending;
    if (this < str) return APT.ComparisonResult.OrderedAscending;
    return APT.ComparisonResult.OrderedSame;
};

String.prototype.apt_compare_options = function(str, mask) {
    var temp = this;
    if ((mask & APT.StringOptions.CaseInsensitiveSearch) == APT.StringOptions.CaseInsensitiveSearch) {
        temp = temp.toLowerCase();
        str = str.toLowerCase();
    }
    if ((mask & APT.StringOptions.LiteralSearch) == APT.StringOptions.LiteralSearch) {

    }
    if ((mask & APT.StringOptions.NumericSearch) == APT.StringOptions.NumericSearch) {

    }
    return temp.apt_compare(str);
};

String.prototype.apt_stringByAppendingPathComponent = function(aString) {
    var path = this.toString();
    if (!path.apt_hasSuffix("/") && path != "")
        path = path + "/";

    return (path + aString);
};

String.prototype.apt_trim = function(chars) {
    str = this;
    next = false;
    min = -1;
    max = str.length;

    do {
        min += 1;
        next = false;
        for (j in chars) {
            if (str[min] == chars[j]) {
                next = true;
            }
        }
    } while (next == true);

    do {
        max -= 1;
        next = false;
        for (j in chars) {
            if (str[max] == chars[j]) {
                next = true;
            }
        }
    } while (next == true);

    return str.substring(min, max + 1);
};

String.prototype.apt_stringByPaddingToLengthWithStringStartingAtIndex = function (newLength, padString, padIndex) {
    var str = new String(this);

    var length = newLength - str.length;
    for (var i = 0; i < length; i += padString.length) {
        if (i == 0) {
            str = str + padString.substr(padIndex);
        } else {
            str = str + padString;
        }
    }
    if (str.length < newLength) {
        str = str + padString.substr(0, newLength - str.length);
    } else if (str.length > newLength) {
        str = str.substr(0, newLength);
    }

    return str;
}

String.NewWithDataUsingEncoding = function(data, encoding) {
    var a = new String();
    var b = data;

    if (encoding == APT.StringEncoding.ASCII) {
        for (i = 0; i < b.length; i++) {
            a += String.fromCharCode(b[i]);
        }
    }
    else {
        throw { Message: "Encoding not supported exception" };
    }
    return a;
};

String.prototype.apt_dataUsingEncoding = function(enc) {
    var ret = new Array();
    if (enc == APT.StringEncoding.ASCII) {
        for (i = 0; i < this.length; i++) {
            ret.push(this.charCodeAt(i));
        }
    }
    else {
        throw { Message: "Encoding not supported exception" };
    }
    return ret;
};

String.prototype.apt_isEqual = function (str) {
    if (str != null && str != undefined && (str instanceof String || typeof str == "string")) {
        return this.valueOf() === str.valueOf();
    }
	return false;
};


String.prototype.apt_propertyListFromStringsFileFormat = function () {
    var textCopy = this.replace(new RegExp("/\\*.*\\*/", 'g'), ""); // delete all comments
    var objects = new Array();
    var values = new Array();
    var keys = new Array();

    var positionsQuotes = APT.Global.getPosition(textCopy, "\"");
    var positionsSemiColon = APT.Global.getPosition(textCopy, "\;");

    if (positionsQuotes.length != 0) {
        for (var i = 0; i < positionsSemiColon.length; i++) {//find ';' that work like separators  and remove them  from the array.
            for (var j = 1; j <= positionsQuotes.length; j++) {
                if (positionsSemiColon[i] > positionsQuotes[j - 1] && positionsSemiColon[i] < positionsQuotes[j]) {
                    positionsSemiColon.splice(i, 1);
                    i--;
                    break;
                }
                if (positionsQuotes[j] > positionsSemiColon[i]) {
                    positionsQuotes.splice(0, 2);
                    break;
                }
                j++
            }
        }

        if (positionsSemiColon.length != 0) { //create the objects separated by ';'
            var obj = textCopy.substring(0, positionsSemiColon[0]);
            objects.push(obj);
            for (var k = 1; k < positionsSemiColon.length; k++) {
                obj = textCopy.substring(positionsSemiColon[k - 1] + 1, positionsSemiColon[k]);
                objects.push(obj);
            }
        }
    } else {//All ';' are separators. Create the objects.
        objects = textCopy.split(";");
    }

    for (var i = 0; i < objects.length; i++) {
        var object = new String(objects[i]);
        var positionEquals;
        var positionEquals1 = APT.Global.getPosition(object, "\=");

        if (positionEquals1.length <= 1) {
            positionEquals = object.indexOf("=");
        } else { // there are more than one '='. Determinate which is a part from an object.

            var quotes = APT.Global.getPosition(object, "\"");
            var equals = APT.Global.getPosition(object, "\=");

            for (var i = 0; i < equals.length; i++) {////find '=' that work like separators  and remove them  from the array.
                for (var j = 1; j <= quotes.length; j++) {
                    if (equals[i] > quotes[j - 1] && equals[i] < quotes[j]) {
                        equals.splice(i, 1);
                        i--;
                        break;
                    }
                    if (quotes[j] > equals[i]) {
                        quotes.splice(0, 2);
                        break;
                    }
                    j++
                }
            }
            positionEquals = equals[0];
        }

        if (positionEquals != -1) {// has key and value
            var key = ((object.substring(0, positionEquals)).replace(/\"/g, "")).replace(/^\s+|\s+$/g, "");
            var value = ((object.substring(positionEquals + 1, object.length)).replace(/\"/g, "")).replace(/^\s+|\s+$/g, "");

            keys.push(key);
            values.push(value);

        } else { //Only has key
            if (object.length != 0) {
                var key = object;

                keys.push(key);
                values.push(null);
            }
        }
    }
    var dictio = APT.Dictionary.dictionaryWithObjectsForKeys(values, keys);
    return dictio;
}


Number.prototype.apt_isEqual = function (obj) {
    if (obj != null && obj != undefined && (obj instanceof Number || typeof obj == "number")) {
        return this.valueOf() === obj.valueOf();
    }
    return false;
};

Number.prototype.apt_compare = function(otherNumber) {
	if (this.valueOf() < otherNumber) {
		return APT.ComparisonResult.OrderedAscending;
	} else if (this.valueOf() > otherNumber){
		return APT.ComparisonResult.OrderedDescending;
	}
	return APT.ComparisonResult.OrderedSame;
};

Array.prototype.apt_copy = function() {
    b = [];
    for (i = 0; i < this.length; i++) {
        b[i] = this[i];
    }
    return b;
};

Array.prototype.apt_deepCopy = function() {
    b = [];
    for (i = 0; i < this.length; i++) {
		if (this[i].apt_copy) {
			b[i] = this[i].apt_copy();
		} else if(this[i].$copy) {
			b[i] = this[i].$copy();
		} else {
			b[i] = JSON.parse(JSON.stringify(this[i]));
		}
    }
    return b;
};

Array.prototype.apt_description = function() {
    var rv = "(\n";
    for (i = 0; i < this.length; i++) {
        rv += "    " + this[i] + "\n";
    }
    rv += ")";

    return rv;
};

Array.prototype.apt_isEqual = function(otherArray) {
	var result = false;
	if(otherArray instanceof Array) {
		if (this === otherArray) {
			result = true;
		} else if (otherArray != null && otherArray != undefined && this.length === otherArray.length) {
			var result = true;
			for (var i = 0; i < this.length; i++) {
				if ((typeof this[i] === "object" && !APT.Global.isEqual(this[i], otherArray[i])) || (typeof this[i] != "object" && this[i] !== otherArray[i])) {
					result = false;
					break;
				}
			}
		}
	}
	return result;
}

APT.Global.CreateStack = function (anArray)
{
    var obj = [];

	if(anArray!== undefined && anArray!==null && anArray.length>0)
	{
	    obj = anArray;
	}

	obj.head = function ()
	{
		if (this.length == 0) return null;
		return this[this.length - 1];
	};

	obj.second = function()
	{
		if (this.length < 2) return null;
		return this[this.length - 2];
	};

	return obj;
};

Date.prototype.apt_description = function() {
    month = parseInt(this.getMonth());
    month++;
    date = this.getDate();
    if (parseInt(date) < 10) {
        date = "0" + date;
    }
    hour = this.toTimeString().substr(0, 8);
    gmt = this.toTimeString().substr(12, 5);

    return this.getFullYear() + "-" + month + "-" + date + " " + hour + gmt;
};

Date.prototype.apt_compare = function(dat) {
    if (this < dat) return APT.ComparisonResult.OrderedAscending;
    if (this > dat) return APT.ComparisonResult.OrderedDescending;
    return APT.ComparisonResult.OrderedSame;
}

Date.prototype.apt_format = function (aFormat) {
	return $.format.date(this, aFormat);
}

Date.prototype.apt_isEqual = function (obj) {
    if (obj != null && obj != undefined && (obj instanceof Date || typeof obj == "object")) {
        return this.getTime() === obj.getTime();
    }
    return false;
};


APT.Graphics2D = function () { };

APT.Graphics2D.addEllipseInRect = function (aContext, aRect) {

	aContext.save();
	var aspectRatio = aRect.size.width / aRect.size.height;
	aContext.scale(aspectRatio, 1);
	var centerX = (2 * aRect.origin.x + aRect.size.width) / (aspectRatio * 2);
	var centerY = (2 * aRect.origin.y + aRect.size.height) / 2;
	var radius = aRect.size.width / (aspectRatio * 2);
	aContext.arc(centerX, centerY, radius, 0, Math.PI * 2, false);
	aContext.restore();
}


APT.Global.ApplicationMain = function (argc, argv, principalClassName, delegateClassName) {

	var app = new application.Application();
	app.exec(delegateClassName);

	return 1;
};

APT.Global.initWhitDelegateClassName = function (app, delegateClassName) {
    var delegate = new window["application"][delegateClassName];
    APT.ApplicationBase.sharedApplication().setDelegate(delegate);

    if (delegate["application_didFinishLaunchingWithOptions"] instanceof Function) {
        delegate.application_didFinishLaunchingWithOptions(this, null);
    } else {
        delegate.applicationDidFinishLaunching(this);
    }

    $(window)[0].onblur = function () {
        if (delegate["applicationWillResignActive"] instanceof Function)
            delegate.applicationWillResignActive(app);
    };

    $(window)[0].onfocus = function () {
        if (delegate["applicationDidBecomeActive"] instanceof Function)
            delegate.applicationDidBecomeActive(app);
    };

    $(window)[0].onbeforeunload = function () {
        if (delegate["applicationWillTerminate"] instanceof Function)
            delegate.applicationWillTerminate(app);
    };

    var downevent;
    var upevent;
    var moveevent;
    var cancelevent;

    if (navigator.msPointerEnabled) {
        downevent = "MSPointerDown";
        upevent = "MSPointerUp";
        moveevent = "MSPointerMove";
        cancelevent = "MSPointerCancel";
    } else {
        downevent = "touchstart";
        upevent = "touchend";
        moveevent = "touchmove";
        cancelevent = "touchcancel";
    }

    $(window).on(downevent, function (event) {
        APT.ApplicationBase.sharedApplication().touchesBegan_withEvent(null, event);
    });

    $(window).on(moveevent, function (event) {
        APT.ApplicationBase.sharedApplication().touchesMoved_withEvent(null, event);
    });

    $(window).on(upevent, function (event) {
        APT.ApplicationBase.sharedApplication().touchesEnded_withEvent(null, event);
    });

    $(window).on(cancelevent, function (event) {
        APT.ApplicationBase.sharedApplication().touchesCancelled_withEvent(null, event);
    });
}
APT.Global.sprintf = function () {

    function str_repeat(i, m) {
        for (var o = []; m > 0; o[--m] = i);
        return o.join('');
    }

    var i = 0, a, f = arguments[i++], o = [], m, p, c, x, s = '';

    while (f) {

        if (m = /^[^\x25]+/.exec(f)) {
            o.push(m[0]);
        } else if (m = /^\x25{2}/.exec(f)) {
            o.push('%');
        } else if (m = /^\x25(?:(\d+)\$)?(\+)?(0|'[^$])?(-)?(\d+)?(?:\.(\d+))?([b-fFoOsuUxX@idc])/.exec(f)) {
            if (((a = arguments[m[1] || i++]) == null) || (a == undefined)) {
                throw ('Too few arguments.');
            }

            if (/[^s]/.test(m[7]) && (typeof (a) != 'number') && m[7] !== "@" && m[7] !== "c") {
                throw ('Expecting number but found ' + typeof (a));
            }

            switch (m[7]) {
                case 'b':
                    a = a.toString(2);
                    break;
                case 'c':
                    if (typeof (a) == 'number') {
                        a = String.fromCharCode(a);
                    }
                    break;
                case 'i':
                case 'd':
                    a = parseInt(a);
                    break;
                case 'e':
                    a = m[6] ? a.toExponential(m[6]) : a.toExponential();
                    break;
                case 'f':
                case 'F':
                    a = m[6] ? parseFloat(a).toFixed(m[6]) : parseFloat(a);
                    break;
                case 'o':
                case 'O':
                    a = parseInt(a).toString(8);
                    break;
                case '@':
                case 's':
                    a = ((a = String(a)) && m[6] ? a.substring(0, m[6]) : a);
                    break;
                case 'u':
                case 'U':
                    a = Math.abs(parseInt(a));
                    break;
                case 'x':
                    a = parseInt(a).toString(16);
                    break;
                case 'X':
                    a = parseInt(a).toString(16).toUpperCase();
                    break;
            }

            a = (/[def]/.test(m[7]) && m[2] && a >= 0 ? '+' + a : a);
            c = m[3] ? m[3] == '0' ? '0' : m[3].charAt(1) : ' ';
            x = m[5] - String(a).length - s.length;
            p = m[5] ? str_repeat(c, x) : '';
            o.push(s + (m[4] ? a + p : p + a));

        } else {
            throw ('Huh ?!');
        }

        f = f.substring(m[0].length);
    }

    return o.join('');

};

APT.Global.createAPTObject = function (className) {
    if (className.indexOf("application") < 0) {
        return new APT[className];
    } else {
        return new application[className.substring(12)];
    }
};

APT.Global.isSafariOrUIWebView = (function () {
    return /(iPhone|iPod|iPad).*AppleWebKit/i.test(navigator.userAgent);
})();

APT.Global.isAndroid = (function () {
    return navigator.userAgent.toLowerCase().indexOf("android") > -1;
})();

APT.Global.loadView = function (container, viewFileName) {
    var path = "";

	loadCSS = function (content) {
		var style = APT.Global.toStaticHTML("<style>" + content + "</style>");
		$("head").append(style);
	};

	if (viewFileName.indexOf(".html") === viewFileName.length - 5) {

		var css = new XMLHttpRequest();
		var cssFile = viewFileName.substring(0, viewFileName.length - 4) + "css";

		console.log("Loading " + cssFile);

		css.open("GET", path + cssFile, false);

		css.send();

		loadCSS(css.response);
	}

	var xml = new XMLHttpRequest();

	console.log("Loading " + viewFileName);

	xml.open("GET", path + viewFileName, false);

	xml.send();

	parser = new DOMParser();
	xmlDoc = parser.parseFromString(xml.response, "text/xml");
	var root = xmlDoc.getElementsByTagName("body")[0];
	for (index in root.childNodes) {
		if (root.childNodes[index].nodeType === 1) {
			root = root.childNodes[index];
			break;
		}
    }

    var view = APT.Global.processElement($(root), view);

    if (container instanceof APT.TabBarItem) {
        container.setTabBarButton(view);
        var imageName = view.jQElement().find("a").attr("data-apt-image");
        var image = null;
        if (imageName !== undefined && imageName.length > 0) {
            image = APT.Image.imageNamed(imageName);
        }
        container.defaultView().initWithTitle_image_tag((view).jQElement().text().trim(), image, 0);
    } else {
        container = view;
    }

	console.log("View " + viewFileName + " loaded");
	return container;
}

APT.Global.getPosition = function (text, delimiter) {
    var l, k = 0;
    var arr = new Array();
    while ((k = text.indexOf(delimiter, l)) != -1) {
        arr.push(k);
        l = k + delimiter.length;
    }
    return arr;
}
